

              page    60, 132 
                                                                                                                                                               
codeseg       segment 
              assume  cs:codeseg, ds:codeseg, ss:codeseg, es:codeseg
              org     100h


start:
              mov     ax,cs
              mov     ds,ax
              mov     ss,ax
              mov     es,ax

              call    cls              ;open File_Input from Dos command line
              mov     ch,0
              mov     cl,ds:80h

              cmp     cl,0
              je      str1

              call    file_input_80h_open  ;open File_Input from keyboard
              jmp     str2

str1:
              call    cls
              call    file_input_kb_open
str2:
              call    bytes_input

              call    file_input_date_time_format
              call    file_input_bytes_to_ascii_number_buff

              mov     ah,5             ;send carriage return to printer
              mov     dl,0dh
              int     21h

              call    cls

              mov     row,11
              mov     col,0
              call    cursor_put

              mov     cx,1040          ;print copyright header
              mov     dx,offset mess13
              call    print_lrg_message
              call    prt_box1

              mov     row,1
              mov     col,0
              call    cursor_put

              mov     ah,2             ;print header on screen
              call    prt_header
              call    crlf
              call    crlf

              mov     dx,offset mess10
              call    prt_mess
              mov     dx,offset mess11
              call    prt_mess

              mov     dx,offset mess14
              call    prt_mess
              call    start_printer
              call    crlf

              mov     rec_size_input,1100
              call    crlf
              call    lpt_header
s2:
              call    ptr_input
              call    read_input       ;output to i_buff
              mov     bx,0

s1:
              mov     ah,5             ;send character to printer
              mov     dl,i_buff[bx]
              int     21h

              inc     bx
              call    print_ptr_input  ;print input file pointer

              mov     dx,0             ;increment input file pointer
              add     rec_ptr_input_l,1
              adc     rec_ptr_input_h,dx

              mov     ax,bytes_input_l ;check for end of file
              cmp     rec_ptr_input_l,ax
              jne     s3
              mov     ax,bytes_input_h
              cmp     rec_ptr_input_h,ax
              je      fini
s3:
              cmp     bx,1000         ;check for end of input buffer
              jne     s1
              je      s2
fini:
              push    bx
              call    print_last_ptr_input
              call    close_input
              pop     bx

              call    cls_bottom

              mov     ax,4c01h
              int     21h
;-----------------------------------------------------------------------------
;data buffer
;-----------------------------------------------------------------------------
blank_buff    db      80 dup (32)
bytes         dw      0
bytes_input_l dw      0
bytes_input_h dw      0
characters    db      0
col           db      0
date_buff     db      '  /  /  $'
day           dw      0
delta         dw      1000
file_input    db      80 dup (0)
file_input_name_len   dw      0
handle_input  dw      0
hours         dw      0
hundreds      dw      0
i_buff        db      1100 dup (0)
kb_buff       db      81
              db      0
              db      81 dup (32)
line_width    db      80
minutes       dw      0
month         dw      0
num_ct        dw      0
number        dw      0
number_buff   db      12 dup (32)
number_byte   db      80
number_l      dw      0
number_h      dw      0
rec_ptr_input_l       dw      0
rec_ptr_input_h       dw      0
rec_size_input        dw      0
row           db      0
seconds       dw      0
time_buff     db      '  :   $'
top_margin    db      4
year          dw      0
xx1           db      0
xx2           db      0
yy1           db      0
yy2           db      0
;-----------------------------------------------------------------------------
mess3         db      'Enter Path And Filename With Extension -- ', '$'
mess4         db      'Error In  Filename -- Try Again', '$'
mess9         db      '                    Number Of  Bytes Processed -- ', '$'
mess10        db      '          o  Set Printer Head On First Line Prior To Turning Printer On', 0dh, 0ah, '$'
mess11        db      '          o  Turn Printer On', 0dh, 0ah, '$'
mess13        db      '********************************************************************************'
              db      '*  COPYHEAD.COM (TM)  (C) Copyright 1992 Soft Exec (R).  All Rights Reserved.  *'
              db      '********************************************************************************'
              db      '    The purchaser of this program is licensed to install and personally use     '
              db      '    this software on any computer that is owned by the purchaser.               '
              db      '                                                                                '
              db      '    Personal use licenses are available for a price of $5.00 and Site licenses  '
              db      '    for multiple users are available for a price of $50.00 via check or money   '
              db      '    order to --                                                                 '
              db      '              Soft Exec                                                         '
              db      '              P.O. Box 1072                                                     '
              db      '              Hunt Valley, Maryland 21031                                       '
              db      '********************************************************************************'
mess14        db      '          o  Depress Enter Key To Start Printing -- ', '$'
;-----------------------------------------------------------------------------     
;subroutines
;-----------------------------------------------------------------------------
;bin_32_to_ascii_dec
;bytes_input
;close_input
;cls
;cls_bottom
;crlf
;cursor_put
;input
;file_input_80h_open
;kb_buff_blanks:       cx, di
;kb_input:    ah,dx
;lprint_crlf
;lpt_header
;open_input
;print_last_ptr_input
;print_lrg_message:   ah, bx -- bytes to cx, offset mess? to dx
;print_ptr_input
;prt_32_binary_to_decimal:    low byte to number_l, high byte to number_h
;prt_box
;prt_box1
;prt_header
;prt_horiz_line
;prt_mess:    ah, offset mess? to dx
;prt_number
;ptr_input
;ptr_input_eof
;prt_vert_line
;read_input
;-----------------------------------------------------------------------------
;subroutine buffer
;-----------------------------------------------------------------------------
bini_dec:
              mov     cx,10000d        ;divide by 10000
              call    dec_div
              mov     cx,1000d         ;divide by 1000
              call    dec_div
              mov     cx,100d          ;divide by 100
              call    dec_div
              mov     cx,10d           ;divide by 10
              call    dec_div
              mov     cx,1d            ;divide by 1
              call    dec_div
              ret
;------------------
bin_32_to_ascii_dec:
              mov     num_ct,0
              call    number_buff_blanks

              cmp     number_h,0
              jne     bin_32_to_ascii_decAA
              cmp     number_l,0
              jne     bin_32_to_ascii_dec7
              mov     number_buff,'0'
              mov     number_buff[1],'0'
              ret
bin_32_to_ascii_dec7:
              mov     ax,number_l
              call    find_1st_sig_number
              mov     dx,0
              jmp     bin_32_to_ascii_decA
bin_32_to_ascii_decAA:
              mov     di,10000
              mov     cx,5
bin_32_to_ascii_decA:
              mov     dx,number_h
              mov     ax,number_l
              mov     bx,di
bin_32_to_ascii_dec1:
              div     bx
              mov     number_h,ax
              mov     number_l,dx
              cmp     ax,10
              jge     bin_32_to_ascii_dec2

              call    bin_32_to_ascii_dec3

              mov     ax,number_l
              mov     dx,0
              loop    bin_32_to_ascii_dec1

              jmp     bin_32_to_ascii_dec6
bin_32_to_ascii_dec2:
              call    find_1st_sig_number
              jmp     bin_32_to_ascii_dec5
bin_32_to_ascii_dec4A:
              mov     dx,0
              div     bx
bin_32_to_ascii_dec5:
              mov     number,dx

              call    bin_32_to_ascii_dec3

              mov     ax,number
              mov     dx,0        ;number_h
              loop    bin_32_to_ascii_dec4A

              mov     di,1000
              mov     cx,4
              mov     dx,0
              mov     ax,number_l
              mov     number_h,0
              mov     bx,di

              jmp     bin_32_to_ascii_dec1
bin_32_to_ascii_dec6:

              ret

bin_32_to_ascii_dec3:
              add     ax,48

              push    di
              mov     di,num_ct
              mov     number_buff[di],al
              pop     di
              inc     num_ct

              mov     ax,di
              mov     bx,10
              mov     dx,0
              div     bx
              mov     bx,ax
              mov     di,ax

              ret

bin_32_to_ascii_dec4:

              ret
;--------------------
bytes_input:
              mov     ah,42h
              mov     al,2
              mov     bx,handle_input
              mov     cx,0
              mov     dx,0
              int     21h
              mov     bytes_input_h,dx
              mov     bytes_input_l,ax
              ret
;--------------------
close_input:
              mov     ah,3eh
              mov     bx,handle_input
              int     21h
              ret
;--------------------
cls:                                   ;clear screen
              mov     row,0
              mov     col,0
              call    cursor_put
              mov     ah,9
              mov     cx,2000
              mov     bh,0
              mov     al,' '
              mov     bl,7
              int     10h
              ret
;--------------------
cls_bottom:                                   ;clear screen
              mov     row,11
              mov     col,0
              call    cursor_put
              mov     ah,9
              mov     cx,1040
              mov     bh,0
              mov     al,' '
              mov     bl,7
              int     10h
              ret
;--------------------
crlf:
              mov     ah,2
              mov     dl,13
              int     21h
              mov     dl,10
              int     21h
              ret
;--------------------
cursor_put:
              mov     dh,row           ;cursor_put
              mov     dl,col
              mov     bh,0
              mov     ah,2
              int     10h
              ret
;--------------------
dec_div:
              mov     ax,bx            ;number high half
              mov     dx,0             ;zero out low half
              div     cx               ;divide by cx
              mov     bx,dx            ;remainder into bx
              mov     dl,al            ;quotient into dl

              add     dl,30h           ;convert to ascii
              mov     ah,2
              int     21H
              ret
;------------------
delta_time:
              cmp     dl,byte ptr hundreds
              jae     delta_time1
              add     dl,100
              sub     dh,1
delta_time1:
              sub     dl,byte ptr hundreds

              cmp     dh,byte ptr seconds
              jae     delta_time2
              add     dh,60
              sub     cl,1
delta_time2:
              sub     dh,byte ptr seconds

              cmp     cl,byte ptr minutes
              jae     delta_time3
              add     cl,60
              sub     ch,1
delta_time3:
              sub     cl,byte ptr minutes

              sub     ch,byte ptr hours
              ret
;--------------------
file_input_80h_open:
              call    kb_buff_blanks   ;reset kb_buff to blanks
              jmp     file_input_80h_open4
file_input_80h_open3:
              call    crlf
              mov     dx,offset mess4  ;Error In Filename -- Try Again
              call    prt_mess         ;Error Message
              
              mov     ax,4c01h
              int     21h

file_input_80h_open4:
              call    crlf
              cld
              mov     cx,0
              mov     cl,ds:80h

              mov     di,0
              mov     bx,0
file_input_80h_open1:
              cmp     byte ptr ds:81h[di],' '
              jne     file_input_80h_open5
              inc     di
              inc     bx
              jmp     file_input_80h_open1
file_input_80h_open5:
              sub     cl,bl
              mov     file_input_name_len,cx
              lea     si,ds:81h[bx]
              lea     di,file_input
rep           movsb

              call    open_input       ;open input file
              jc      file_input_80h_open3
              ret
;-------------------
file_input_bytes_to_ascii_number_buff:                     ;print bytes_input_l
              mov     dx,bytes_input_l
              mov     number_l,dx
              mov     dx,bytes_input_h
              mov     number_h,dx
              call    bin_32_to_ascii_dec
              ret
;--------------------
file_input_date_time:
              mov     ah,57h
              mov     al,0
              mov     bx,handle_input
              int     21h
              mov     seconds,cx

              mov     day,dx
              and     day,11111b       ;day
              mov     cl,5
              shr     dx,cl
              mov     month,dx
              and     month,1111b      ;month
              mov     cl,4
              shr     dx,cl
;              and     dx,1111111b
              add     dx,80
              and     dx,11111111b
              mov     year,dx          ;year
              int     21h

              mov     dx,seconds
              and     seconds,11111b   ;seconds
              mov     cl,5
              shr     dx,cl
              mov     minutes,dx
              and     minutes,111111b  ;minutes
              mov     cl,6
              shr     dx,cl
              mov     hours,dx
              and     hours,11111b     ;hours

              ret
;--------------------
file_input_date_time_format:
              call    file_input_date_time

              call    number_buff_blanks
              mov     number_h,0
              mov     ax,hours
              cmp     ax,13
              jl      file_input_date_time_format4
              sub     ax,12
file_input_date_time_format4:
              mov     number_l,ax
              call    bin_32_to_ascii_dec
              cmp     hours,12
              jl      file_input_date_time_format5
              cmp     hours,24
              je      file_input_date_time_format5
              mov     time_buff[5],'p'
              jmp     file_input_date_time_format6
file_input_date_time_format5:
              mov     time_buff[5],'a'
file_input_date_time_format6:
              cmp     number_buff[1],' '
              je      file_input_date_time_format7
              mov     al,number_buff[0]
              mov     time_buff[0],al
              mov     al,number_buff[1]
              mov     time_buff[1],al
              jmp     file_input_date_time_format8
file_input_date_time_format7:
              mov     al,number_buff[0]
              mov     time_buff[1],al
file_input_date_time_format8:
              call    number_buff_blanks
              mov     number_h,0
              mov     ax,minutes
              mov     number_l,ax
              call    bin_32_to_ascii_dec
              cmp     number_buff[1],' '
              je      file_input_date_time_format9
              mov     al,number_buff[0]
              mov     time_buff[3],al
              mov     al,number_buff[1]
              mov     time_buff[4],al
              jmp     file_input_date_time_format10
file_input_date_time_format9:
              mov     time_buff[3],'O'
              mov     al,number_buff[0]
              mov     time_buff[4],al
file_input_date_time_format10:
              call    number_buff_blanks
              mov     number_h,0
              mov     ax,seconds
              mov     number_l,ax
              call    bin_32_to_ascii_dec

              call    number_buff_blanks
              mov     number_h,0
              mov     ax,month
              mov     number_l,ax
              call    bin_32_to_ascii_dec
              cmp     number_buff[1],' '
              je      file_input_date_time_format11
              mov     al,number_buff[0]
              mov     date_buff[0],al
              mov     al,number_buff[1]
              mov     date_buff[1],al
              jmp     file_input_date_time_format12
file_input_date_time_format11:
              mov     al,number_buff[0]
              mov     date_buff[1],al
file_input_date_time_format12:
              call    number_buff_blanks
              mov     number_h,0
              mov     ax,day
              mov     number_l,ax
              call    bin_32_to_ascii_dec
              cmp     number_buff[1],' '
              je      file_input_date_time_format13
              mov     al,number_buff[0]
              mov     date_buff[3],al
              mov     al,number_buff[1]
              mov     date_buff[4],al
              jmp     file_input_date_time_format14
file_input_date_time_format13:
              mov     date_buff[3],'O'
              mov     al,number_buff[0]
              mov     date_buff[4],al
file_input_date_time_format14:
              call    number_buff_blanks
              mov     number_h,0
              mov     ax,year
              mov     number_l,ax
              call    bin_32_to_ascii_dec
              cmp     number_buff[1],' '
              je      file_input_date_time_format15
              mov     al,number_buff[0]
              mov     date_buff[6],al
              mov     al,number_buff[1]
              mov     date_buff[7],al
              jmp     file_input_date_time_format16
file_input_date_time_format15:
              mov     al,number_buff[0]
              mov     date_buff[7],al
file_input_date_time_format16:

              ret
;-------------------
file_input_kb_open:
              call    kb_buff_blanks   ;reset kb_buff to blanks
              mov     dx,offset mess3  ;Enter Path And Filename With Extension
              call    prt_mess
              call    kb_input         ;keyboard input
              jmp     file_input_kb_open4
file_input_kb_open3:
              call    crlf
              mov     dx,offset mess4  ;Error In Filename -- Try Again
              call    prt_mess         ;Error Message
              call    crlf
              jmp     file_input_kb_open
file_input_kb_open4:
              call    crlf
              cld
              mov     cx,0
              mov     cl,kb_buff[1]
              mov     file_input_name_len,cx
              lea     si,kb_buff[2]
              lea     di,file_input
rep           movsb

              call    open_input       ;open input file
              jc      file_input_kb_open3
              ret
;-------------------
find_1st_sig_number:
              mov     number,ax
              mov     cx,5
              mov     di,10000
              mov     bx,di
find_1st_sig_number3:
              mov     dx,0
              div     bx
              mov     number,dx

              cmp     ax,0
              jne     find_1st_sig_number4
              mov     ax,di
              mov     bx,10
              mov     dx,0
              div     bx
              mov     bx,ax
              mov     di,ax
              mov     ax,number
              sub     cx,1
              jmp     find_1st_sig_number3
find_1st_sig_number4:
              ret
;--------------------
lpt_header:
              mov     ah,5             ;send header and crlf to printer
              mov     dl,0dh           ;carriage return to printer
              int     21h
              call    prt_header
              call    lprint_crlf
              call    lprint_crlf

              ret
;--------------------
kb_buff_blanks:
              mov     di,2
              mov     cx,81
kb_buff_blanks1:
              mov     kb_buff[di],32
              inc     di
              loop    kb_buff_blanks1
              ret
;-------------------
kb_input:
              mov     ah,0ah
              mov     dx,offset kb_buff
              int     21h
              ret
;------------------
lprint_crlf:
              mov     ah,5
              mov     dl,13
              int     21h
              mov     dl,10
              int     21h

              ret
;-------------------
number_buff_blanks:
              cld
              mov     cx,12
              lea     si,blank_buff
              lea     di,number_buff
rep           movsb
              ret
;--------------------
open_input:
              mov     ah,3dh           ;open file for input
              mov     al,2
              mov     dx,offset file_input
              int     21h
              mov     handle_input,ax
              ret
;--------------------
print_lrg_message:
              mov     ah,40h
              mov     bx,0001
              int     21h
              ret
;--------------------
print_ptr_input:                       ;print bytes_input_l
              mov     dx,bytes
              cmp     dx,delta
              jne     print_ptr_input1
              mov     bytes,0
print_last_ptr_input:
              push    ax
              push    bx
              push    cx
              push    dx
              push    di

              mov     dx,rec_ptr_input_l
              mov     number_l,dx
              mov     dx,rec_ptr_input_h
              mov     number_h,dx
              call    bin_32_to_ascii_dec
              mov     dx,offset mess9
              call    prt_mess
              call    prt_number
              mov     ah,2
              mov     dl,0dh
              int     21h

              pop     di
              pop     dx
              pop     cx
              pop     bx
              pop     ax
print_ptr_input1:
              inc     bytes

              ret
;--------------------
prt_32_binary_to_decimal:         ;low byte to number_l, high byte to number_h
              mov     di,0
              mov     cx,12

              push    ax
              push    bx
              push    cx
              push    dx
              push    di

              call    bin_32_to_ascii_dec

              pop     di
              pop     dx
              pop     cx
              pop     bx
              pop     ax

prt_32_binary_to_decimal1:
              cmp     number_buff[di],' '
              je      prt_32_binary_to_decimal2
              mov     dl,number_buff[di]
              int     21h
              inc     di
              loop    prt_32_binary_to_decimal1

prt_32_binary_to_decimal2:
              ret
;--------------------
prt_box:
              mov     ah,2

              mov     dl,yy1           ;yy1 - prt upper left
              mov     row,dl
              mov     dl,xx1           ;xx1
              mov     col,dl
              call    cursor_put
              mov     dl,0dah
              int     21h

              mov     dl,yy1           ;yy1 - prt upper right
              mov     row,dl
              mov     dl,xx2           ;xx2
              mov     col,dl
              call    cursor_put
              mov     dl,0bfh
              int     21h

              mov     dl,yy2           ;yy2 - prt lower left
              mov     row,dl
              mov     dl,xx1           ;xx1
              mov     col,dl
              call    cursor_put
              mov     dl,0c0h
              int     21h

              mov     dl,yy2           ;yy2 - prt lower right
              mov     row,dl
              mov     dl,xx2           ;xx2
              mov     col,dl
              call    cursor_put
              mov     dl,0d9h
              int     21h

              mov     dl,yy1           ;yy1 - prt top line
              mov     row,dl
              call    prt_horiz_line

              mov     dl,yy2           ;yy2 - prt bottom line
              mov     row,dl
              call    prt_horiz_line

              mov     dl,xx1           ;xx1 - prt left line
              mov     col,dl
              call    prt_vert_line

              mov     dl,xx2           ;xx2 - prt right line
              mov     col,dl
              call    prt_vert_line

              mov     row,13
              call    prt_horiz_line

              mov     col,0
              call    cursor_put
              mov     dl,0c3h
              int     21h

              mov     col,79
              call    cursor_put
              mov     dl,0b4h
              int     21h

              ret
;top T - 0c2h, bottom T - 0c1h, left T - 0c3h, right T - 0b4h, cross - 0c5h
;--------------------
prt_box1:
              mov     yy1,11           ;yy1
              mov     yy2,23           ;yy2
              mov     xx1,0            ;xx1
              mov     xx2,79           ;xx2
              call    prt_box

              ret
;--------------------
prt_header:                            ;ah,2 for screen and ah,5 for printer
              mov     cx,30
prt_header10:
              mov     dl,' '
              int     21h
              loop    prt_header10

              mov     di,0             ;print Input_File date
              mov     cx,8
prt_header4:
              mov     dl,date_buff[di]
              int     21h
              inc     di
              loop    prt_header4

              call    prt_header2      ;print blanks

              mov     di,0             ;print Input_File time
              mov     cx,6
prt_header5:
              mov     dl,time_buff[di]
              int     21h
              inc     di
              loop    prt_header5

              call    prt_header2

              mov     dx,bytes_input_l
              mov     number_l,dx
              mov     dx,bytes_input_h
              mov     number_h,dx
              call    prt_32_binary_to_decimal

prt_header7:
              mov     dl,' '
              int     21h
              mov     dl,'b'
              int     21h
              mov     dl,'y'
              int     21h
              mov     dl,'t'
              int     21h
              mov     dl,'e'
              int     21h
              mov     dl,'s'
              int     21h

              call    prt_header2      ;print blanks

              mov     dx,0
              mov     di,0
              mov     cx,file_input_name_len
prt_header8:
              cmp     file_input[di],'\'
              pushf
              inc     di
              popf
              jne     prt_header9
              mov     dx,di
prt_header9:
              loop    prt_header8

              mov     di,dx             ;print path and filename
              mov     cx,file_input_name_len
              sub     cx,di
prt_header1:
              mov     dl,file_input[di]
              int     21h
              inc     di
              loop    prt_header1

              ret

prt_header2:
              mov     di,0             ;print blanks
              mov     cx,2
prt_header3:
              mov     dl,' '
              int     21h
              inc     di
              loop    prt_header3

              ret
;-------------------
prt_horiz_line:
              mov     dl,xx1           ;xx1
              mov     col,dl
              add     col,1
              call    cursor_put               
              mov     ch,0
              mov     cl,xx2           ;xx2
              sub     cl,xx1           ;xx1
              sub     cl,1
prt_horiz_line1:
              mov     dl,0c4h
              int     21h
              loop    prt_horiz_line1

              ret
;--------------------
prt_mess:
              mov     ah,9
              int     21h
              ret
;------------------
prt_number:
              mov     di,0
prt_number1:
              cmp     number_buff[di],' '
              je      prt_number2
              mov     dl,number_buff[di]
              mov     ah,2
              int     21h
              inc     di
              jmp     prt_number1
prt_number2:
              ret
;--------------------
prt_vert_line:
              mov     dl,yy1           ;yy1
              mov     row,dl
              add     row,1
              mov     ch,0
              mov     cl,yy2           ;yy2
              sub     cl,yy1           ;yy1
              sub     cl,1
prt_vert_line1:
              call    cursor_put
              mov     dl,0b3h
              int     21h
              inc     row
              loop    prt_vert_line1

              ret
;--------------------
prt_time:
              mov     ah,2
              mov     bx,hours
              call    bini_dec
              mov     dl,' '
              int     21h

              mov     bx,minutes
              call    bini_dec
              mov     dl,' '
              int     21h

              mov     bx,seconds
              call    bini_dec
              mov     dl,' '
              int     21h

              mov     bx,hundreds
              call    bini_dec
              call    crlf
              ret
;--------------------
ptr_input:
              push    ax
              push    bx
              push    cx
              push    dx
              push    di
              mov     bx,handle_input
              mov     ah,42h
              mov     al,0
              mov     cx,rec_ptr_input_h
              mov     dx,rec_ptr_input_l
              int     21h
              pop     di
              pop     dx
              pop     cx
              pop     bx
              pop     ax
              ret
;--------------------
read_input:
              push    bx
              push    di
              mov     ah,3fh           ;read input file
              mov     bx,handle_input
              mov     cx,rec_size_input
              mov     dx,offset i_buff
              int     21h
              pop     di
              pop     bx
              ret
;--------------------
start_printer:
              call    kb_buff_blanks
              call    kb_input
              cmp     kb_buff[2],0dh
              jl      start_printer

              ret
;-----------------------------------------------------------------------------
codeseg       ends
              end     start
;------------------------------------------------------------------------------

